<bugID>1324814<Summary>devtools leaks browser.xul window through _pingTelemetry, gDevTools, and TabTarget.onRemotenessChange</Summary><Description>I got a leaked browser.xul in FF52 dev edition today.  The gc/gc logs suggest its some devtools or e10s code keeping stuff alive here:

bkelly@kosh /c/devel/tmp/cclogs/browserxul
$ /c/devel/heapgraph/find_roots.py cc-edges.1424.1482251995.log 0000019283FEE000
Parsing cc-edges.1424.1482251995.log. Done loading graph.

0000019286897060 [JS Object (Window)]
    --[UnwrapDOMObject(obj)]--&gt; 0000019283FEE000 [nsGlobalWindow # 112 inner chrome://browser/conten
t/browser.xul]

    Root 0000019286897060 is a marked GC object.


bkelly@kosh /c/devel/tmp/cclogs/browserxul
$ /c/devel/heapgraph/find_roots.py gc-edges.1424.1482251995.log -bro 0000019286897060
Parsing gc-edges.1424.1482251995.log. Done loading graph.

via mCallback :
000001928CB312A0 [Proxy &lt;no private&gt;]
    --[private]--&gt; 0000019280969F60 [Object &lt;no private&gt;]
    --[_pingTelemetry]--&gt; 0000019282D84640 [Function exports.gDevToolsBrowser._pingTelemetry]
    --[fun_environment]--&gt; 00000192845D6640 [LexicalEnvironment &lt;no private&gt;]
    --[gDevTools]--&gt; 0000019280969A60 [Object &lt;no private&gt;]
    --[emit]--&gt; 0000019282DBAD30 [Function bound emit]
    --[fun_environment]--&gt; 0000019282DC8100 [Call &lt;no private&gt;]
    --[thisArg]--&gt; 0000019280969C40 [Object &lt;no private&gt;]
    --[_eventEmitterListeners]--&gt; 00000192FCE82070 [Map 00000192833FDD60]
    --[value]--&gt; 000001928CBC13A0 [Array &lt;no private&gt;]
    --[objectElements[1]]--&gt; 000001928D8419C0 [Function TabTarget.prototype.onRemotenessChange/on]
    --[fun_environment]--&gt; 0000019293D93C80 [LexicalEnvironment &lt;no private&gt;]
    --[tab]--&gt; 00000192FE8BE4E0 [Proxy &lt;no private&gt;]
    --[private]--&gt; 000001928D031A00 [XULElement &lt;no private&gt;]
    --[group]--&gt; 000001928685CEB0 [object_group]
    --[group_global]--&gt; 0000019286897060 [Window &lt;no private&gt;]</Description></bugID>